Loading...
Searching...
No Matches
ArcSector Class Reference

The ArcSector class is a convenience class for creating an arc disk (e.g., part of a circle) from a MeshGeometry. More...

`#include <arcsector.h>`

Inheritance diagram for ArcSector:

## Public Member Functions

void | setArcSector (const Vector3f &origin, const Vector3f &startEdge, const Vector3f &normal, float degreesCCW, float resolutionDeg)
Public Member Functions inherited from MeshGeometry
| MeshGeometry (const MeshGeometry &other)
MeshGeometry & | operator= (MeshGeometry)
void | accept (Visitor &) override
void | render (const Camera &camera) override
| Render the mesh geometry.
void | clear () override
size_t | vertexCount () const
size_t | indexCount () const
size_t | triangleCount () const
Core::Array< PackedVertex > | vertices ()
Core::Array< unsigned int > | triangles ()
unsigned int | addVertices (const Core::Array< Vector3f > &vertices, const Core::Array< Vector3f > &normals, const Core::Array< Vector4ub > &colors)
unsigned int | addVertices (const Core::Array< Vector3f > &vertices, const Core::Array< Vector3f > &normals, const Core::Array< Vector3ub > &colors)
unsigned int | addVertices (const Core::Array< Vector3f > &vertices, const Core::Array< Vector3f > &normals)
void | addTriangle (size_t index1, size_t index2, size_t index3)
void | addTriangles (const Core::Array< unsigned int > &indices)
void | setColor (const Vector3ub &c)
Vector3ub | color () const
void | setOpacity (unsigned char opacity_)
unsigned char | opacity () const
Public Member Functions inherited from Drawable
| Drawable (const Drawable &other)
Drawable & | operator= (Drawable)
const GeometryNode * | parent () const
| Get a pointer to the drawable object's parent.
GeometryNode * | parent ()
void | setVisible (bool visibility)
| Set the visibility of the drawable object.
bool | isVisible () const
| Get the current visibility of the drawable.
Identifier & | identifier ()
const Identifier & | identifier () const
virtual std::multimap< float, Identifier > | hits (const Vector3f &rayOrigin, const Vector3f &rayEnd, const Vector3f &rayDirection) const
virtual Core::Array< Identifier > | areaHits (const Frustrum &f) const
void | setRenderPass (RenderPass pass)
RenderPass | renderPass () const

## Additional Inherited Members

Static Public Attributes inherited from MeshGeometry
static const unsigned int | InvalidIndex
Protected Member Functions inherited from Drawable
void | setParent (GeometryNode *parent)
| Set the parent node for the node.
Protected Attributes inherited from Drawable
GeometryNode * | m_parent
bool | m_visible
RenderPass | m_renderPass
Identifier | m_identifier

## Detailed Description

<avogadro/rendering/arcsector.h>

See also
  ArcStrip for the edge of a circle.

## Member Function Documentation

## setArcSector()

void setArcSector | ( | const Vector3f & | origin,
|  | const Vector3f & | startEdge,
|  | const Vector3f & | normal,
|  | float | degreesCCW,
|  | float | resolutionDeg )

Define the sector.

Parameters

  origin | Center of the circle from which the arc is cut.
  startEdge | A vector defining an leading edge of the sector. The direction is used to fix the sector's rotation about the origin, and the length defines the radius of the sector.
  normal | The normal direction to the plane of the sector.
  degreesCCW | The extent of the sector, measured counter-clockwise from startEdge in degrees.
  resolutionDeg | The radial width of each triangle used in the sector approximation in degrees. This will be adjusted to fit an integral number of triangles in the sector. Smaller triangles (better approximations) are chosen if adjustment is needed.

The documentation for this class was generated from the following file:

- arcsector.h